> ## Documentation Index
> Fetch the complete documentation index at: https://docs.insighto.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Toolfunction

> Create a toolfunction



## OpenAPI

````yaml https://api.insighto.ai/api/v1/openapi.json post /api/v1/toolfunction
openapi: 3.1.0
info:
  title: Ragify
  version: v1
servers: []
security: []
paths:
  /api/v1/toolfunction:
    post:
      tags:
        - Tool Function
      summary: Create Toolfunction
      description: Create a toolfunction
      operationId: create_toolfunction_api_v1_toolfunction_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IToolFunctionCreate'
        required: true
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IPostResponseBase_IToolFunctionCreate_'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - Your API Key: []
        - HTTPBearer: []
components:
  schemas:
    IToolFunctionCreate:
      properties:
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        tool_function_type:
          anyOf:
            - $ref: '#/components/schemas/IToolFunctionTypeEnum'
            - type: 'null'
        details:
          additionalProperties: true
          type: object
          title: Details
          default: {}
        tool_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Tool Id
        is_enabled:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Is Enabled
          default: false
      type: object
      required:
        - name
        - description
        - tool_function_type
      title: IToolFunctionCreate
    IPostResponseBase_IToolFunctionCreate_:
      properties:
        message:
          anyOf:
            - type: string
            - type: 'null'
          title: Message
          default: Data created successfully
        meta:
          anyOf:
            - additionalProperties: true
              type: object
            - {}
            - type: 'null'
          title: Meta
          default: {}
        data:
          anyOf:
            - $ref: '#/components/schemas/IToolFunctionCreate'
            - type: 'null'
      type: object
      title: IPostResponseBase[IToolFunctionCreate]
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    IToolFunctionTypeEnum:
      type: string
      enum:
        - sdk
        - curl
        - query_index
      title: IToolFunctionTypeEnum
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    Your API Key:
      type: apiKey
      description: >-
        Your API key for authentication. You can generate it from the
        **Settings** page. Format: starts with `in-`.
      in: query
      name: api_key
    HTTPBearer:
      type: http
      scheme: bearer

````